Index: /pykota/trunk/pykota/storages/sql.py
===================================================================
--- /pykota/trunk/pykota/storages/sql.py (revision 2686)
+++ /pykota/trunk/pykota/storages/sql.py (revision 2697)
@@ -517,12 +517,20 @@
     def addUser(self, user) :        
         """Adds a user to the quota storage, returns it."""
-        self.doModify("INSERT INTO users (username, limitby, balance, lifetimepaid, email, overcharge) VALUES (%s, %s, %s, %s, %s, %s)" % \
-                                         (self.doQuote(self.userCharsetToDatabase(user.Name)), self.doQuote(user.LimitBy or 'quota'), self.doQuote(user.AccountBalance or 0.0), self.doQuote(user.LifeTimePaid or 0.0), self.doQuote(user.Email), self.doQuote(user.OverCharge)))
+        self.doModify("INSERT INTO users (username, limitby, balance, lifetimepaid, email, overcharge, description) VALUES (%s, %s, %s, %s, %s, %s, %s)" % \
+                                         (self.doQuote(self.userCharsetToDatabase(user.Name)), \
+                                          self.doQuote(user.LimitBy or 'quota'), \
+                                          self.doQuote(user.AccountBalance or 0.0), \
+                                          self.doQuote(user.LifeTimePaid or 0.0), \
+                                          self.doQuote(user.Email), \
+                                          self.doQuote(user.OverCharge), \
+                                          self.doQuote(self.userCharsetToDatabase(user.Description)))
         return self.getUser(user.Name)
         
     def addGroup(self, group) :        
         """Adds a group to the quota storage, returns it."""
-        self.doModify("INSERT INTO groups (groupname, limitby) VALUES (%s, %s)" % \
-                                          (self.doQuote(self.userCharsetToDatabase(group.Name)), self.doQuote(group.LimitBy or "quota")))
+        self.doModify("INSERT INTO groups (groupname, limitby, description) VALUES (%s, %s, %s)" % \
+                                          (self.doQuote(self.userCharsetToDatabase(group.Name)), \
+                                           self.doQuote(group.LimitBy or "quota"), \
+                                           self.doQuote(self.userCharsetToDatabase(group.Description)))
         return self.getGroup(group.Name)
 
Index: /pykota/trunk/pykota/storages/ldapstorage.py
===================================================================
--- /pykota/trunk/pykota/storages/ldapstorage.py (revision 2686)
+++ /pykota/trunk/pykota/storages/ldapstorage.py (revision 2697)
@@ -871,4 +871,6 @@
         if user.Email :
             newfields.update({self.info["usermail"]: user.Email})
+        if user.Description is not None : 
+            newfields.update({"description": self.userCharsetToDatabase(user.Description)})
         mustadd = 1
         if self.info["newuser"].lower() != 'below' :
@@ -932,4 +934,6 @@
                       "pykotaLimitBy" : (group.LimitBy or "quota"),
                     } 
+        if group.Description is not None : 
+            newfields.update({"description": self.userCharsetToDatabase(group.Description)})
         mustadd = 1
         if self.info["newgroup"].lower() != 'below' :
Index: /pykota/trunk/pykota/storage.py
===================================================================
--- /pykota/trunk/pykota/storage.py (revision 2696)
+++ /pykota/trunk/pykota/storage.py (revision 2697)
@@ -40,4 +40,5 @@
         self.parent = parent
         self.ident = None
+        self.Description = None
         self.isDirty = False
         self.Exists = False
@@ -54,5 +55,4 @@
         StorageObject.__init__(self, parent)
         self.Name = name
-        self.Description = None
         self.LimitBy = None
         self.AccountBalance = None
@@ -123,5 +123,4 @@
         self.AccountBalance = None
         self.LifeTimePaid = None
-        self.Description = None
         
     def setLimitBy(self, limitby) :    
@@ -159,5 +158,4 @@
         self.PricePerPage = None
         self.PricePerJob = None
-        self.Description = None
         self.MaxJobSize = None
         self.PassThrough = None
@@ -462,5 +460,4 @@
         StorageObject.__init__(self, parent)
         self.BillingCode = name
-        self.Description = None
         self.PageCounter = None
         self.Balance = None