Index: pykota/trunk/bin/pkusers
===================================================================
--- pykota/trunk/bin/pkusers (revision 2704)
+++ pykota/trunk/bin/pkusers (revision 2705)
@@ -59,7 +59,4 @@
   -g | --groups        Edit users groups instead of users.
                           
-  -p | --prototype u|g Uses user u or group g as a prototype to create
-                       or modify datas.
-                       
   -o | --overcharge f  Sets the overcharging factor applied to the user 
                        when computing the cost of a print job. Positive or 
@@ -114,10 +111,9 @@
 examples :                              
 
-  $ pkusers --add -p jerome john paul george ringo/ringo@example.com
+  $ pkusers --add john paul george ringo/ringo@example.com
   
   This will add users john, paul, george and ringo to the quota
-  database, and set their account information based on user 
-  jerome's own account. User jerome must already exist.
-  User ringo's email address will also be set to 'ringo@example.com'
+  database. User ringo's email address will also be set to 
+  'ringo@example.com'
   
   $ pkusers --ingroups coders,it jerome
@@ -131,9 +127,10 @@
   when printing.
   
-  $ pkusers --balance +10.0 jerome
+  $ pkusers --balance +10.0 --comment "He paid with his blood !" jerome
   
   This will increase jerome's account balance by 10.0 (in your
   own currency). You can decrease the account balance with a
   dash prefix, and set it to a fixed amount with no prefix.
+  A comment will be stored for this balance change.
   
   $ pkusers --delete jerome rachel
@@ -275,6 +272,4 @@
                                                 'noprint', 'nochange') :
                         raise PyKotaCommandLineError, _("Invalid limitby value %s") % options["limitby"]
-                    if limitby in ('noquota', 'nochange') :    
-                        options["noquota"] = 1
                     if (limitby in ('nochange', 'noprint')) and options["groups"] :    
                         raise PyKotaCommandLineError, _("Invalid limitby value %s") % options["limitby"]
@@ -305,17 +300,4 @@
                     description = options["description"].strip()
                     
-                if options["prototype"] :    
-                    protoentry = getattr(self.storage, "get%s" % suffix)(options["prototype"])
-                    if not protoentry.Exists :
-                        raise PyKotaCommandLineError, _("Prototype object %s not found in Quota Storage.") % protoentry.Name
-                    else :    
-                        limitby = protoentry.LimitBy
-                        balancevalue = protoentry.AccountBalance
-                        if balancevalue is not None :
-                            balance = str(abs(balancevalue))
-                        else :    
-                            balance = None
-                        overcharge = getattr(protoentry, "OverCharge", None)
-                    
                 nbtotal = len(entries)
                 for i in range(nbtotal) :        
@@ -342,8 +324,8 @@
                      "comment" : "", \
                    }
-        short_options = "hvaD:dgl:rsp:o:i:b:C:L"
+        short_options = "hvaD:dgl:rso:i:b:C:L"
         long_options = ["help", "version", "add", "description=", \
                         "delete", "groups", "list", "remove", \
-                        "skipexisting", "overcharge=", "prototype=", \
+                        "skipexisting", "overcharge=", \
                         "ingroups=", "limitby=", "balance=", "comment=", \
                        ]
@@ -367,5 +349,4 @@
         options["remove"] = options["r"] or options["remove"]
         options["skipexisting"] = options["s"] or options["skipexisting"]
-        options["prototype"] = options["p"] or options["prototype"]
         options["limitby"] = options["l"] or options["limitby"]
         options["balance"] = options["b"] or options["balance"] 
Index: pykota/trunk/man/sv_SE/pkusers.1
===================================================================
--- pykota/trunk/man/sv_SE/pkusers.1 (revision 2703)
+++ pykota/trunk/man/sv_SE/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR
Index: pykota/trunk/man/pt/pkusers.1
===================================================================
--- pykota/trunk/man/pt/pkusers.1 (revision 2703)
+++ pykota/trunk/man/pt/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR
Index: pykota/trunk/man/tr/pkusers.1
===================================================================
--- pykota/trunk/man/tr/pkusers.1 (revision 2703)
+++ pykota/trunk/man/tr/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR
Index: pykota/trunk/man/el_GR/pkusers.1
===================================================================
--- pykota/trunk/man/el_GR/pkusers.1 (revision 2703)
+++ pykota/trunk/man/el_GR/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR
Index: pykota/trunk/man/de/pkusers.1
===================================================================
--- pykota/trunk/man/de/pkusers.1 (revision 2703)
+++ pykota/trunk/man/de/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR
Index: pykota/trunk/man/nb_NO/pkusers.1
===================================================================
--- pykota/trunk/man/nb_NO/pkusers.1 (revision 2703)
+++ pykota/trunk/man/nb_NO/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR
Index: pykota/trunk/man/pkusers.1
===================================================================
--- pykota/trunk/man/pkusers.1 (revision 2703)
+++ pykota/trunk/man/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR
Index: pykota/trunk/man/zh_TW/pkusers.1
===================================================================
--- pykota/trunk/man/zh_TW/pkusers.1 (revision 2703)
+++ pykota/trunk/man/zh_TW/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR
Index: pykota/trunk/man/pt_BR/pkusers.1
===================================================================
--- pykota/trunk/man/pt_BR/pkusers.1 (revision 2703)
+++ pykota/trunk/man/pt_BR/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR
Index: pykota/trunk/man/fr/pkusers.1
===================================================================
--- pykota/trunk/man/fr/pkusers.1 (revision 2703)
+++ pykota/trunk/man/fr/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR
Index: pykota/trunk/man/es/pkusers.1
===================================================================
--- pykota/trunk/man/es/pkusers.1 (revision 2703)
+++ pykota/trunk/man/es/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR
Index: pykota/trunk/man/pl/pkusers.1
===================================================================
--- pykota/trunk/man/pl/pkusers.1 (revision 2703)
+++ pykota/trunk/man/pl/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR
Index: pykota/trunk/man/th/pkusers.1
===================================================================
--- pykota/trunk/man/th/pkusers.1 (revision 2703)
+++ pykota/trunk/man/th/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR
Index: pykota/trunk/man/it/pkusers.1
===================================================================
--- pykota/trunk/man/it/pkusers.1 (revision 2703)
+++ pykota/trunk/man/it/pkusers.1 (revision 2705)
@@ -36,7 +36,4 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Edit users groups instead of users.
-.TP
-\fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to create
-or modify datas.
 .TP
 \fB\-o\fR | \fB\-\-overcharge\fR f
@@ -99,10 +96,9 @@
 examples :
 .IP
-\f(CW$ pkusers --add -p jerome john paul george ringo/ringo@example.com\fR
+\f(CW$ pkusers --add john paul george ringo/ringo@example.com\fR
 .IP
 This will add users john, paul, george and ringo to the quota
-database, and set their account information based on user
-jerome's own account. User jerome must already exist.
-User ringo's email address will also be set to 'ringo@example.com'
+database. User ringo's email address will also be set to
+\&'ringo@example.com'
 .IP
 \f(CW$ pkusers --ingroups coders,it jerome\fR
@@ -116,9 +112,10 @@
 when printing.
 .IP
-\f(CW$ pkusers --balance +10.0 jerome\fR
+\f(CW$ pkusers --balance +10.0 --comment "He paid with his blood !" jerome\fR
 .IP
 This will increase jerome's account balance by 10.0 (in your
 own currency). You can decrease the account balance with a
 dash prefix, and set it to a fixed amount with no prefix.
+A comment will be stored for this balance change.
 .IP
 \f(CW$ pkusers --delete jerome rachel\fR