Index: /pykota/trunk/bin/pkusers
===================================================================
--- /pykota/trunk/bin/pkusers (revision 2707)
+++ /pykota/trunk/bin/pkusers (revision 2719)
@@ -73,4 +73,6 @@
                               must already exist in the Quota Storage.
                        
+  -L | --list          Lists users or groups.
+  
   -l | --limitby l     Choose if the user/group is limited in printing                     
                        by its account balance or by its page quota.
Index: /pykota/trunk/man/sv_SE/pkusers.1
===================================================================
--- /pykota/trunk/man/sv_SE/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/sv_SE/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
Index: /pykota/trunk/man/pt/pkusers.1
===================================================================
--- /pykota/trunk/man/pt/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/pt/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
Index: /pykota/trunk/man/tr/pkusers.1
===================================================================
--- /pykota/trunk/man/tr/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/tr/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
Index: /pykota/trunk/man/el_GR/pkusers.1
===================================================================
--- /pykota/trunk/man/el_GR/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/el_GR/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
Index: /pykota/trunk/man/de/pkusers.1
===================================================================
--- /pykota/trunk/man/de/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/de/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
Index: /pykota/trunk/man/nb_NO/pkusers.1
===================================================================
--- /pykota/trunk/man/nb_NO/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/nb_NO/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
Index: /pykota/trunk/man/pkusers.1
===================================================================
--- /pykota/trunk/man/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
Index: /pykota/trunk/man/zh_TW/pkusers.1
===================================================================
--- /pykota/trunk/man/zh_TW/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/zh_TW/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
Index: /pykota/trunk/man/pt_BR/pkusers.1
===================================================================
--- /pykota/trunk/man/pt_BR/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/pt_BR/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
Index: /pykota/trunk/man/fr/pkusers.1
===================================================================
--- /pykota/trunk/man/fr/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/fr/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
Index: /pykota/trunk/man/es/pkusers.1
===================================================================
--- /pykota/trunk/man/es/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/es/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
Index: /pykota/trunk/man/pl/pkusers.1
===================================================================
--- /pykota/trunk/man/pl/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/pl/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
Index: /pykota/trunk/man/th/pkusers.1
===================================================================
--- /pykota/trunk/man/th/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/th/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
Index: /pykota/trunk/man/it/pkusers.1
===================================================================
--- /pykota/trunk/man/it/pkusers.1 (revision 2705)
+++ /pykota/trunk/man/it/pkusers.1 (revision 2719)
@@ -52,4 +52,7 @@
 listed, separated by commas. The groups
 must already exist in the Quota Storage.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l